# Test cases for Lab 9 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#-------------------------------------------------------------------------------------------

_target_list = [
   'inBounds', 'searchDirection', 'searchFromPosition', 'searchGrid', 'findwords',
   ]

#------------------------------------------------------------------------------------------------
# auxiliary functions

_grid1 = [['c', 'a', 't', 'n', 'x', 'f'],
          ['k', 'c', 'o', 'r', 'e', 'r'],
          ['d', 'i', 'o', 'k', 'c', 'o'],
          ['l', 'r', 'a', 'w', 'i', 'g'],
          ['d', 'n', 'i', 'l', 'm', 'i'],
          ['s', 'o', 'w', 'b', 'l', 'p'],
          ['n', 'o', 'g', 'a', 'r', 'd']]

#------------------------------------------------------------------------------------------------

_test_cases = {
   'inBounds':{
      1: ('', (5, 0, _grid1,), True),
      2: ('', (7, 1, _grid1,), False),
      3: ('', (5, -1, _grid1,), False),
      4: ('', (6, 5, _grid1,), True),
      5: ('', (7, 5, _grid1,), False),
      6: ('', (6, 6, _grid1,), False),
      7: ('', (0, 0, _grid1,), True),
      8: ('', (-1, 0, _grid1,), False),
      9: ('', (0, -1, _grid1,), False),
      10: ('', (-2, 8, _grid1), False),
   },
   'searchDirection':{
      1: ('', ('frog', 0, 5, 'down', _grid1), True,
          'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('frog', 0, 5, 'right', _grid1), False),
      3: ('', ('froggy', 0, 5, 'down', _grid1), False),
      4: ('', ('cow', 2, 4, 'right', _grid1), False),
      5: ('', ('dragon', 6, 5, 'left', _grid1), True,
          'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      6: ('', ('dragon', 6, 5, 'up', _grid1), False),
      7: ('', ('cow', 1, 1, 'right', _grid1), False),
      8: ('', ('cow', 1, 1, 'down right', _grid1), True,
          'cow', 'found', ('1, 1','1,1','1 1'), 'down right'),
      9: ('', ('snake', 5, 0, 'up right', _grid1), True,
          'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      10: ('', ('snakefest', 5, 0, 'up right', _grid1), False),
   },
   'searchFromPosition':{
      1: ('', ('frog', 0, 5, _grid1), True, 'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('cow', 1, 1, _grid1), True, 'cow', 'found', ('1, 1','1,1','1 1'), 'right'),
      3: ('', ('cow', 0, 0, _grid1), False),
      4: ('', ('cow', 2, 4, _grid1), False),
      5: ('', ('dragon', 6, 5, _grid1), True, 'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      6: ('', ('dragon', 6, 0, _grid1), False),
      7: ('', ('owl', 6, 1, _grid1), True, 'owl', 'found', ('6, 1','6,1','6 1'), 'up right'),
      8: ('', ('snake', 5, 0, _grid1), True, 'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      9: ('', ('rock', 1, 3, _grid1), True, 'rock', 'found', ('1, 3','1,3','1 3'), 'left'),
      10: ('', ('mice', 4, 4, _grid1), True, 'mice', 'found', ('4, 4','4,4','4 4'), 'up'),
   },
   'searchGrid':{
      1: ('', ('frog', _grid1), True, 'frog', 'found', ('0, 5','0,5','0 5'), 'down'),
      2: ('', ('cow', _grid1), True, 'cow', 'found', ('1, 1','1,1','1 1'), 'right'),
      3: ('', ('dragon', _grid1), True, 'dragon', 'found', ('6, 5','6,5','6 5'), 'left'),
      4: ('', ('owl', _grid1), True, 'owl', 'found', ('6, 1','6,1','6 1'), 'up right'),
      5: ('', ('snake', _grid1), True, 'snake', 'found', ('5, 0','5,0','5 0'), 'up right'),
      6: ('', ('rock', _grid1), True, 'rock', 'found', ('1, 3','1,3','1 3'), 'left'),
      7: ('', ('mice', _grid1), True, 'mice', 'found', ('4, 4','4,4','4 4'), 'up'),
      8: ('', ('puppy', _grid1), False),
      9: ('', ('froggy', _grid1), False),
      10: ('', ('cats', _grid1), False),
   },
   'findwords':{
      1: ('frog\nquit', ('grid1.txt',), None,
          'frog found', ('0, 5','0,5','0 5'), 'down',),
      2: ('frog\ncow\ndragon\nowl\nsnake\nquit', ('grid1.txt',), None,
          'frog found', ('0, 5','0,5','0 5'), 'down',
          'cow found', ('1, 1','1,1','1 1'), 'right',
          'dragon found', ('6, 5','6,5','6 5'), 'left',
          'owl found', ('6, 1','6,1','6 1'), 'up right',
          'snake found', ('5, 0','5,0','5 0'), 'up right'),
      3: ('puppy\nquit', ('grid1.txt',), None,
          'not found'),
      4: ('froggy\nquit', ('grid1.txt',), None,
          'not found'),
      5: ('lion\npig\nbird\nquit', ('grid1.txt',), None,
          'lion found', ('3, 0', '3,0', '3 0'), 'up right',
          'pig found', ('5, 5', '5,5', '5 5'), 'up',
          'bird found', ('5, 3', '5,3', '5 3'), 'up left'),
   },

}
